HDU 1087 FatMouse and Cheese (记忆化搜索)

题面

Problem Description
FatMouse has stored some cheese in a city. The city can be considered as a square grid of dimension n: each grid location is labelled (p,q) where 0 <= p < n and 0 <= q < n. At each grid location Fatmouse has hid between 0 and 100 blocks of cheese in a hole. Now he's going to enjoy his favorite food.

FatMouse begins by standing at location (0,0). He eats up the cheese where he stands and then runs either horizontally or vertically to another location. The problem is that there is a super Cat named Top Killer sitting near his hole, so each time he can run at most k locations to get into the hole before being caught by Top Killer. What is worse -- after eating up the cheese at one location, FatMouse gets fatter. So in order to gain enough energy for his next run, he has to run to a location which have more blocks of cheese than those that were at the current hole.

Given n, k, and the number of blocks of cheese at each grid location, compute the maximum amount of cheese FatMouse can eat before being unable to move.

Input
There are several test cases. Each test case consists of

a line containing two integers between 1 and 100: n and k
n lines, each with n numbers: the first line contains the number of blocks of cheese at locations (0,0) (0,1) ... (0,n-1); the next line contains the number of blocks of cheese at locations (1,0), (1,1), ... (1,n-1), and so on.
The input ends with a pair of -1's.

Output
For each test case output in a line the single integer giving the number of blocks of cheese collected.

Sample Input
3 1
1 2 5
10 11 6
12 12 7
-1 -1

Sample Output
37

思路

大概讲一下题面的意思,就是一只老鼠被猫追杀,他在一个矩阵里面,这里面每一个格子,都有他藏的食物,他现在想要做饿死鼠,一个单位时间他可以最多走k步,方向为水平或者垂直,而且每次只能往藏更多食物的格子里面走,问我们直到无路可走,他最多可以吃多少,然后再上路。看了下题面,矩阵么就直接搜索了,我们枚举每次的步数和四周的方向,然后取四周最大的格子走,我们会发现这个算法会有大量浪费,所以加一个记忆化。这里提一下和滑雪的不同,滑雪那道题目是搜索步数,所以只用取大的时候+1就可以了,差别不大。(原谅我最近都在做记忆化搜索,hhha)

代码实现

#include<cstdio>
#include<algorithm>
#include<cmath>
#include<cstring>
#include<queue>
#include<iostream>
#include<string>
#include<vector>
using namespace std;
#define eps 1e-4
const int maxn=10005;
const int N = 105;
int maze[N][N];
int dp[N][N];
int n,k;
int moving[4][2]={{1,0},{-1,0},{0,-1},{0,1}};
int dfs (int x,int y) {
   if (dp[x][y]) return dp[x][y] ;
   int temp=0;
   for (int i=1;i<=k;i++) 
    for (int j=0;j<4;j++) {
       int nx=x+moving[j][0]*i;
       int ny=y+moving[j][1]*i;
       if (nx>=1&&ny>=1&&nx<=n&&ny<=n&&maze[nx][ny]>maze[x][y]) {
          int ans=dfs(nx,ny);
          if (ans>temp) {
             temp=ans;
          }  
       }
    }
    dp[x][y]=temp+maze[x][y];
   return dp[x][y];
}
int main () {
   while (cin>>n>>k) {
      if (n==-1&&k==-1) break;
      for (int i=1;i<=n;i++) 
       for (int j=1;j<=n;j++)  cin>>maze[i][j];
      memset (dp,0,sizeof (dp));
      cout<<dfs(1,1)<<endl;
   }
    return 0;
}
原文地址:https://www.cnblogs.com/hhlya/p/13152421.html